EclaireXL - Feature #7

Implement 12C vga/hdmi support
04/04/2017 09:07 PM - admin

Status: New Start date: 04/04/2017
Priority: Normal Due date:

Assignee: % Done: 0%
Category: Estimated time: 0:00 hour
Target version:

Description

Try the 12C support on the new board.

Initially for presence detection

Latest for checking modes

Its via a mux chip so we can independently address both ports

Related issues:

Related to Bug #19: PAL VGA Synch issues (screen is not centered Closed 05/30/2017

History

#1 - 05/11/2017 08:26 PM - foft
- File PCA9540B.pdf added

Attached mux/level converter chip data sheet

#2 - 05/11/2017 08:28 PM - foft
- File 24c04.pdf added

EDID is apparently one of these | can access at address 0x50

#3 - 05/11/2017 08:30 PM - foft
- File ddcciv1ri.pdf added

DDC looks a little funkier

#4 - 05/11/2017 08:34 PM - foft

Used this controller for the ADC on v1: https://eewiki.net/, /view .action? ld=10125324

So | guess | just need to wire this to the ZPU, then | can experiment with this in firmware.

| guess a write FIFO that captures 16 bits (7 bit address, R/W and data). Then a fifo for the reply. + A way of telling when its all stopped.

#5 - 05/31/2017 07:04 PM - foft
- Related to Bug #19: PAL VGA Synch issues (screen is not centered added

#6 - 02/04/2018 09:25 PM - admin

- Priority changed from Normal to Urgent

Going to at least check this chip is wired properly before the new boards are ordered
#7 - 02/06/2018 09:28 PM - foft

Writing some code to say:

select channell

read selected channel

write to random slave on channeld

select channel0

12/17/2025

1/2



https://eewiki.net/pages/viewpage.action?pageId=10125324

read selected channel
write to random slave on channel0

Might be working, but need to work out how to check... | guess | can stick the scope in i2c decode mode on the vga or hdmi port (fiddly...) and see if |
see anything.

#8 - 02/06/2018 09:36 PM - foft

Picoscope has i2c debugging and linux drivers:-) Installed them and will connect that up and take a look tomorrow.

#9 - 02/06/2018 09:38 PM - foft

Looking on signaltap looks like slave reads of the control register are not working. Hmmm.
#10 - 02/07/2018 08:00 PM - foft
| had the pin assignments backwards. | can now write 4/5 to the control register and read it back. This should be channel select.

Next up... checking that what | write makes it to the VGA and HDMI port. | guess | could try speaking to them. Annoying thing here is | only have one
monitor so would need to disconnect it to check!

#11 - 02/07/2018 08:23 PM - foft
VGA is working... receiving “00 FF FF FF FF FF FF 00 10 AC ..."
Now for HDMI

#12 - 02/07/2018 08:25 PM - foft
HDMI is working too... “00 FF FF FF FF FF FF 00 10 AC ...

#13 - 02/07/2018 08:25 PM - foft

- Priority changed from Urgent to Normal

Setting back to normal since the hardware side is working fine.

#14 - 02/07/2018 08:51 PM - foft
Added to the video settings 'VGA connected' and 'HDMI connected' which look for the start of the DDC sequence '00FF'

Files

PCA9540B.pdf 290 KB 05/11/2017 foft
24c04.pdf 163 KB 05/11/2017 foft
ddcciviri.pdf 127 KB 05/11/2017 foft
